# Version: 1.2
echo "[xto] start_commonsw.sh started..."
ifconfig eth1 10.0.0.1
cat /opt/novexx/data/nextgen_top.rbf > /dev/fpga_load

ARTIFACT_NAME=xto
CURRENT_FILE=/opt/novexx/bin/${ARTIFACT_NAME}
NEW_FILE_DEBUG=${CURRENT_FILE}-debug
NEW_FILE_DMALLOC=${CURRENT_FILE}-dmalloc
NEW_FILE_RELEASE=${CURRENT_FILE}-release

if [[ -f "${NEW_FILE_DEBUG}" || -f "${NEW_FILE_DMALLOC}" || -f "${NEW_FILE_RELEASE}" ]]; then
	echo "[xto] new version found"
	echo "[xto] update started..."
	
	# per retrocompatibilita' con le stampanti in cui si sta eseguendo 
	# un eseguibile che si chiama xtoi
	XTOI_ARTIFACT_NAME=xtoi
	XTOI_CURRENT_FILE=/opt/novexx/bin/${XTOI_ARTIFACT_NAME}
	if [ -f "${XTOI_CURRENT_FILE}" ]; then
		echo "[xto] ${XTOI_CURRENT_FILE} found"
	    rm ${XTOI_CURRENT_FILE}
	    echo "[xto] ${XTOI_CURRENT_FILE} removed"
	fi
	
	if [ -f "${CURRENT_FILE}" ]; then
		echo "[xto] ${CURRENT_FILE} found"
	    rm ${CURRENT_FILE}
	    echo "[xto] ${CURRENT_FILE} removed"
	fi
	
	if [ -f "${NEW_FILE_DEBUG}" ]; then
		echo "[xto] ${NEW_FILE_DEBUG} found"
		mv ${NEW_FILE_DEBUG} ${CURRENT_FILE}
		echo "[xto] ${NEW_FILE_DEBUG} renamed to ${CURRENT_FILE}"
	fi
	
	if [ -f "${NEW_FILE_DMALLOC}" ]; then
		echo "[xto] ${NEW_FILE_DMALLOC} found"
		mv ${NEW_FILE_DMALLOC} ${CURRENT_FILE}
		echo "[xto] ${NEW_FILE_DMALLOC} renamed to ${CURRENT_FILE}"
	fi
	
	if [ -f "${NEW_FILE_RELEASE}" ]; then
		echo "[xto] ${NEW_FILE_RELEASE} found"
		mv ${NEW_FILE_RELEASE} ${CURRENT_FILE}
		echo "[xto] ${NEW_FILE_RELEASE} renamed to ${CURRENT_FILE}"
	fi
	
	sync
	echo "[xto] update finished"
fi

if [ -f "${CURRENT_FILE}" ]; then
	echo "[xto] ${CURRENT_FILE} found"
	${CURRENT_FILE} nowatchdog &
	
	XTO_PROCESS_ID=$(pidof ${CURRENT_FILE})
	echo "[xto] XTO_PROCESS_ID: ${XTO_PROCESS_ID}"
	if [[ -z $XTO_PROCESS_ID ]]; then
    	echo "[xto] **ERROR*: !!!${CURRENT_FILE} start failed!!!"
    else
    	echo "[xto] ${CURRENT_FILE} is running"
	fi
fi

echo "[xto] start_commonsw.sh finished"
